10  E$=CHR$(27):Z1$=E$+"E"
20  PRINT Z1$
30  REM
40  REM
50  REM<UNK! {0009}><UNK! {0009}><UNK! {0009}>CONVERTED FOR MBASIC BY:
60  REM<UNK! {0009}><UNK! {0009}><UNK! {0009}><UNK! {0009}><UNK! {0009}><UNK! {0009}>PAUL MAYER WB9ZHG
70  REM<UNK! {0009}><UNK! {0009}><UNK! {0009}><UNK! {0009}><UNK! {0009}><UNK! {0009}>3516 RUBY STREET
80  REM<UNK! {0009}><UNK! {0009}><UNK! {0009}><UNK! {0009}><UNK! {0009}><UNK! {0009}>FRANKLIN PARK, IL 60131
90  REM
100  REM                 COUNTRY LIST UPDATE 5/86 BY:
110  REM                                             DICK GENAILLE W4UW
120  REM                                             719 QUARTERSTAFF RD
130  REM                                             WINSTON-SALEM, NC 27104
140  REM
150  PRINT "                     BEAM HEADINGS-5/86 COUNTRY LIST":PRINT
160  PRINT "THIS PROGRAM CALCULATES ANTENNA DIRECTION AND DISTANCE TO VARIOUS POINTS"
170  PRINT "ON EARTH STARTING FROM AN ARBITRARY (FIXED) LOCATION.  THE ALGORITHM IS"
180  PRINT "DESCRIBED IN THE ARRL ANTENNA BOOK.":PRINT :PRINT :PRINT
190  E1$="-----"
200  E1$=E1$+E1$
210  E1$=E1$+E1$
220  E1$=E1$+E1$
230  E1$=E1$+E1$
240  H4=25
250  Q$=CHR$(34)
260  REM GET THE LOCATION FROM WHICH CALCULATIONS ARE MADE
270  PRINT "ENTER LATITUDE AND LONGITUDE OF HOME QTH USED"
280  PRINT "  FOR CALCULATIONS, THE FORMAT TO USE IS:"
290  PRINT "   41,56,"Q$;"N"Q$;",87,49,"Q$;"W"Q$
300  PRINT "  WHICH MEANS 41 DEG 56 MIN NORTH, 87 DEG 49 MIN WEST"
310  PRINT: PRINT
320  P1=3.14159
330  INPUT A0,A1,D1$,O0,O1,D2$
340  IF A0<>90 GOTO 380
350  PRINT "N/S POLE NOT A VALID QTH"
360  GOTO 270
370  IF A0>90 OR A0<-90 OR O0>180 OR O0<0 GOTO 270
380  PRINT Z1$:PRINT "ENTER HEADER SUCH AS "Q$;"PAUL MAYER - WB9ZHG - FRANKLIN PARK - ILLINOIS - USA"Q$
390  PRINT :PRINT :PRINT
400  INPUT W8$
410  PRINT Z1$
420  REM THIS "HEADER" WILL CUSTOMIZE THE PRINTOUT FOR THE INDIVIDUAL QTH.
430  LPRINT E1$
440  FOR X=1 TO 5: LPRINT:NEXT X
450  N4=1
460  LPRINT TAB( 29)"COUNTRY LIST REV 5/86"
470  D=57.2958
480  REM U0 AND U1 ARE LATITUDE AND LONGITUDE (RESPECTIVELY) IN DECIMAL DEG
490  U0=(A0+A1/60)/D
500  U1=(O0+O1/60)/D
510  IF D1$="S" THEN U0=-U0
520  IF D2$="E" THEN U1=-U1
530  FOR X=1 TO 4:LPRINT:NEXT X
540  N4=N4+3
550  REM N4 KEEPS TRACK OF THE LINE NUMBER ON THE PAGE TO MAKE ALL PAGES THE
560  REM     SAME LENGTH
570  LPRINT TAB( 18)"ALL MEASUREMENTS ARE TO (1) MAJOR CITY  OR"
580  LPRINT TAB( 16)"(2) GEOGRAPHICAL CENTER OF AREA IF NO CITY NOTED"
590  LPRINT:LPRINT TAB( 15)"ALL BEARINGS ARE MEASURED IN DEGREES EAST OF NORTH"
600  LPRINT TAB( 27)"RANGE IS IN STATUTE MILES"
610  LPRINT
620  LPRINT TAB( 28)"RANGE AND BEARING FROM:"
630  LPRINT
640  LPRINT TAB( 40-LEN(W8$)/2)W8$
650  LPRINT TAB( 34)"LOCATED AT:"
660  LPRINT TAB( 29)A0" DEG "A1" MIN "D1$
670  LPRINT TAB( 29)O0" DEG "O1" MIN "D2$
680  FOR X=1 TO 5:LPRINT:NEXT X
690  REM LPRINT THE HEADING FOR EACH PAGE
700  LPRINT:LPRINT TAB( 5)"CALL"TAB( 22)"QTH"TAB( 53)"BEARING"TAB( 67)"RANGE"
710  N4=N4+H4
720  REM GET THE DATA FOR EACH COUNTRY
730  READ C$,Q$,H1,H2
740  IF C$="END" THEN GOTO 1040
750  H1=H1/D
760  H2=H2/D
770  X=U1-H2
780  IF X>P1 THEN  X=X-2*P1
790  IF X<-P1 THEN X=X+2*P1
800  REM LINES 420 THRU 510 DO THE ACTUAL GREAT CIRCLE CALCULATIONS
810  T0=SIN(U0)*SIN(H1)+COS(U0)*COS(H1)*COS(X)
820  IF T0<>0 THEN F1=ATN(SQR(1-T0*T0)/T0)
830  IF T0=0 THEN F1=P1/2
840  IF T0<0 THEN F1=F1+P1
850  T1=SIN(H1)-SIN(U0)*COS(F1)
860  T1=T1/(COS(U0)*SIN(F1))
870  IF T1<>0 THEN F2=ATN(SQR(1-T1*T1)/T1)
880  IF T1=0 THEN F2=P1/2
890  IF T1<0 THEN F2=F2+P1
900  F1=F1*60*D*1.152
910  F1=INT(F1)
920  F2=F2*D
930  F3=INT(F2+0.5)
940  IF X<0 THEN F3=INT(360-F2)
950  LPRINT TAB(5) C$ TAB(18) Q$ TAB(55) F3 TAB(66) F1
960  N4=N4+1
970  IF N4<60 GOTO 730
980  N4=5
990  FOR X=1 TO 6:LPRINT:NEXT X
1000  LPRINT E1$
1010  FOR X=1 TO 3:LPRINT:NEXT X
1020  LPRINT TAB( 5)"CALL"TAB( 22)"QTH"TAB( 53)"BEARING"TAB( 67)"RANGE"
1030  GOTO 730
1040  FOR N8=N4 TO  56
1050  LPRINT
1060  NEXT 
1070  PRINT "FOR ADDITIONAL COPIES OR UPDATED COUNTRY LIST"
1080  PRINT "CONTACT  DR. ART EPSTEIN - WB2WMJ"
1090  PRINT "         47 PARK CIRCLE"
1100  PRINT "         GREAT NECK, NY 11024"
1110  FOR X=1 TO 4:LPRINT:NEXT X
1120  LPRINT E1$
1130  END 
1140  REM THE DATA STATEMENTS BELOW GIVE THE (CONSTANT) DATA FOR EACH COUNTRY
1150  REM   THAT IS, THE AMATEUR RADIO PREFIX, THE COUNTRY NAME,
1160  REM   AND THE LATITUDE AND LONGITUDE INFORMATION.
1170  REM TO ELIMINATE UNNECESSARY CALCULATIONS, THE INPUT DATA IS EXPRESSED
1180  REM   IN SIGNED DECIMAL DEGREES.  "-" INDICATES SOUTH OR EAST.
1190  DATA "A2","BOTSWANA",-22,-24
1200  DATA "A3","TONGA ",-20,175
1210  DATA "A4","OMAN",22,-58
1220  DATA "A5","BHUTAN",27.5,-90.1
1230  DATA "A6","UNITED ARAB EMIRATES",24,-56
1240  DATA "A7","QATAR",25,-51.2
1250  DATA "A9","BAHRAIN",26,-50.5
1260  DATA "AP","PAKISTAN",30,-70
1270  DATA "BV","TAIWAN",23.5,-121
1280  DATA "BY","CHINA,PEKING",39.9,-116.4
1290  DATA "C2","NAURU",-.5,-167.9
1300  DATA "C3","ANDORRA",42.5,-1.5
1310  DATA "C5","THE GAMBIA",13.4,16
1320  DATA "C6","BAHAMAS",24.25,76
1330  DATA "C8,C9","MOZAMBIQUE",-18,-36
1340  DATA "CE","CHILE",-30,71
1350  DATA "CE9","SOUTH SHETLAND IS",-62,60
1360  DATA "CE0A","EASTER IS",-27.1,109.3
1370  DATA "CE0X","SAN FELIX",-26.3,80.1
1380  DATA "CE0Z","JUAN FERNANDEZ",-33,80
1390  DATA "CM,CO","CUBA",21.5,80
1400  DATA "CN","MOROCCO",32,5.8
1410  DATA "CP","BOLIVIA",-17,65
1420  DATA "CT","PORTUGAL",39.5,8
1430  DATA "CT2","AZORES",38.5,28
1440  DATA "CT3","MADEIRA IS",32.7,17
1450  DATA "CX","URUGUAY",-33,56
1460  DATA "D2,3","ANGOLA",-12.5,-18.5
1470  DATA "D4","CAPE VERDE IS",16,24
1480  DATA "D6","COMOROS",-12.2,-44.3
1490  DATA "DA-DL","FED. REP. OF GERMANY",51,-9
1500  DATA "DU","PHILLIPINES",12.5,-123
1510  DATA "EA-EH","SPAIN",40,4
1520  DATA "EA6","BALEARIC IS",39.5,-3
1530  DATA "EA8","CANARY IS",28,15.5
1540  DATA "EA9","CEUTA & MELILLA",35.3,2.98
1550  DATA "EI","IRELAND",53,8
1560  DATA "EL","LIBERIA",6,10
1570  DATA "EP","IRAN",32,-53
1580  DATA "ET","ETHIOPIA",9,-41
1590  DATA "F","FRANCE",46,-2
1600  DATA "FB8W","CROZET IS",-46,-52
1610  DATA "FB8X","KERGUELEN IS",-49.3,-69.2
1620  DATA "FB8Z","AMSTERDAM & ST. PAUL IS",-37.8,-77.5
1630  DATA "FC","CORSICA",42,-9
1640  DATA "FG","GUADELOUPE",16.2,61.6
1650  DATA "FH","MAYOTTE",-12.2,-44.3
1660  DATA "FK","NEW CALEDONIA",-22.3,-166.5
1670  DATA "FM","MARTINIQUE",14.7,61
1680  DATA "FO","CLIPPERTON",10.3,109.2
1690  DATA " ","FR POLYNESIA",-17.5,149.6
1700  DATA "FP","ST PIERRE & MIQUELON IS",46.7,52.35
1710  DATA "FR","JUAN DE NOVA",-17.1,-42.8
1720  DATA " ","GLORIOSO",-11,-48
1730  DATA " ","REUNION",-21.1,-55.6
1740  DATA " ","TROMELIN IS",-15.9,-52.2
1750  DATA "FS","ST MARTIN",18.1,63.1
1760  DATA "FW","WALLIS & FUTUNA",-14,177
1770  DATA "FY","FR GUIANA",4,53
1780  DATA "G","ENGLAND",51.5,1.5
1790  DATA "GD","ISLE OF MAN",54.2,4.5
1800  DATA "GI","NORTHERN IRELAND",54.6,6.8
1810  DATA "GJ","JERSEY",49.3,2.2
1820  DATA "GM","SCOTLAND",57,4
1830  DATA "GU","GUERNSEY",49.5,2.6
1840  DATA "GW","WALES",52.5,3.5
1850  DATA "H4,VR4","SOLOMON IS",-8,-159
1860  DATA "H5","BOPHUTHATSWANA",-30,-25
1870  DATA "HA,HG","HUNGARY",47,-20
1880  DATA "HB","SWITZERLAND",46,-8.5
1890  DATA "HB0","LIECHTENSTEIN",48.4,-9.25
1900  DATA "HC","ECUADOR",-2,77.5
1910  DATA "HC8","GALAPAGOS IS",-.5,90.5
1920  DATA "HH","HAITI",19,72.4
1930  DATA "HI","DOMINICAN REP",19,70.7
1940  DATA "HK","COLOMBIA",4,72
1950  DATA "HK0","MALPELO",4,81.6
1960  DATA " ","SAN ANDRES",13.4,81.4
1970  DATA "HL,HM","KOREA",37.5,-126.9
1980  DATA "HP","PANAMA",9,80
1990  DATA "HR","HONDURAS",15,86.5
2000  DATA "HS","THAILAND",15,-100
2010  DATA "HT,YN","NICARAGUA",13,85
2020  DATA "HV","VATICAN CITY",41.9,-12.45
2030  DATA "HZ,7Z","SAUDI ARABIA",25,-45
2040  DATA "I-IZ","ITALY",42.8,-12.8
2050  DATA "IS","SARDINIA",40,-9
2060  DATA "J2,FL8","DJIBOUTI",11.6,-43.2
2070  DATA "J3,VP2G","GRENADA",12.1,61.7
2080  DATA "J5","GUINEA BISSAU",12,15
2090  DATA "J6,VP2L","ST. LUCIA",14,61
2100  DATA "J7,VP2D","DOMINICA",15.5,61.35
2110  DATA "J8,VP2S","ST. VINCENT",13.1,61.15
2120  DATA "JA-JS","JAPAN",36,-138
2130  DATA "JD","OGASAWARA",27,-142.2
2140  DATA " ","MINAMI TORISHIMA",24.3,-154
2150  DATA " ","OKINO TORI-SHIMA..",25,-150
2160  DATA "JT","MONGOLIA",47.9,-106.9
2170  DATA "JW","SVALBARD",78,-20
2180  DATA "JX","JAN MAYEN",71,-8.3
2190  DATA "JY","JORDAN",31,-36
2200  DATA "K1,AA-AL,N,W","CONN",41.7,72.5
2210  DATA " ","MAINE",45.5,69
2220  DATA " ","MASS",42.4,72
2230  DATA " ","N.H.",44,71.5
2240  DATA " ","R.I.",41.7,71.5
2250  DATA " ","VT",43.5,73
2260  DATA "K2,AA-AL,N,W","N.J.",40.25,74.5
2270  DATA " ","N.Y.",42.9,75.5
2280  DATA " ","Poughkeepsie, N.Y.",41.42,73.56
2290  DATA "K3,AA-AL,N,W","DEL",39.2,75.5
2300  DATA " ","MD",39,76.5
2310  DATA " ","PENN",41,78
2320  DATA "K4,AA-AL,N,W","ALA",33,86.5
2330  DATA " ","FLA",28.5,82
2340  DATA " ","GA",33,83
2350  DATA " ","KY",37.5,85
2360  DATA " ","N.C.",35.5,78.5
2370  DATA " ","S.C.",33.5,80.5
2380  DATA " ","TENN",36,86
2390  DATA " ","VA",38,78.5
2400  DATA "K5,AA-AL,N,W","ARK",34.7,92.4
2410  DATA " ","LA",31.5,92.5
2420  DATA " ","MISS",33,89.7
2430  DATA " ","N.M.",34,106
2440  DATA " ","OKLA",35.5,96.5
2450  DATA " ","TEXAS",32,98
2460  DATA "K6,AA-AL,N,W","CALIF",37,120
2470  DATA "K7,AA-AK,N,W","ARIZ",33.3,111.6
2480  DATA " ","IDAHO",44,114
2490  DATA " ","MONT",47,110
2500  DATA " ","NEV",39,117
2510  DATA " ","OREG",44,120
2520  DATA " ","UTAH",39,112
2530  DATA " ","WASH",47,120
2540  DATA " ","WYOM",43,107.5
2550  DATA "K8,AA-AL,N,W","MICH",44,85
2560  DATA " ","OHIO",40,82.5
2570  DATA " ","W.VA.",39,80.5
2580  DATA "K9,AA-AL,N,W","ILL",40,89
2590  DATA " ","IND",40,86.5
2600  DATA " ","WISC",44.5,90
2610  DATA "K0,AA-AL,N,W","COLO",39,105
2620  DATA " ","IOWA",42,94
2630  DATA " ","KANSAS",38.5,98
2640  DATA " ","MINN",46.5,94.5
2650  DATA " ","MO",38.5,92.2
2660  DATA " ","NEBR",41.5,100
2670  DATA " ","N.D.",47.5,100
2680  DATA " ","S.D.",44.5,100
2690  DATA "KB6,KH1","BAKER & HOWLAND",0.3,176.5
2700  DATA "KC4,KP1","NAVASSA IS",18.4,75
2710  DATA "KC6","FED. STATES OF MICRONESIA",8,-145
2720  DATA " ","REP. OF BELAU",8,-135
2730  DATA "KG4","GUANTANAMO",20,75.15
2740  DATA "KG6,KH2","GUAM",13.45,-144.8
2750  DATA "KH0,KG6R,S,T","MARIANA IS",12,-154
2760  DATA "KH","HAWAII",19.5,155.5
2770  DATA " ","KURE IS",28.4,178.8
2780  DATA "KJ","JOHNSTON IS",16.75,169.55
2790  DATA "KL7,AL7","ALASKA",65,153
2800  DATA "KM,KH4","MIDWAY IS",28.2,177.25
2810  DATA "KP4","PUERTO RICO",18.25,66.5
2820  DATA "KP4,KP5","DESECHEO IS.",18.22,68.19
2830  DATA "KP6,KH5","KINGMAN REEF",6.4,166.4
2840  DATA " ","PALMYRA GROUP",5.85,162.1
2850  DATA "KS6,KH8","AMERICAN SAMOA",-14.3,170
2860  DATA "KV,KP2","VIRGIN IS",18.3,64.7
2870  DATA "KW6,KH9","WAKE IS",19.3,-166.6
2880  DATA "KX6","MARSHALL IS",13,-165
2890  DATA "LA-LJ","NORWAY",62,-10
2900  DATA "LU,AZ","ARGENTINA",-34,64
2910  DATA "LX","LUXEMBOURG",49.75,-6.1
2920  DATA "LZ","BULGARIA",43,-25
2930  DATA "OA","PERU",-10,76
2940  DATA "OD","LEBANON",34,-36
2950  DATA "OE","AUSTRIA",47.3,-13.3
2960  DATA "OH","FINLAND",64,-26
2970  DATA "OH0","ALAND IS",60.25,-20
2980  DATA "OJ0","MARKET",60.3,-19.15
2990  DATA "OK","CZECHOSLOVAKIA",49.5,-17
3000  DATA "ON","BELGIUM",50.8,-4
3010  DATA "OX,XP","GREENLAND",71,40
3020  DATA "OY","FAROE IS",62,7
3030  DATA "OZ","DENMARK",56,-10
3040  DATA "P2","PAPUA NEW GUINEA",-7,-147
3050  DATA "PA-PI","NETHERLANDS",52.25,-5.5
3060  DATA "PJ2,3,4,9","NETH. ANTILLES",12.25,69
3070  DATA "PJ5,6,7,8","ST. MAARTEN, SABA, ST. EUSTATIUS",18.1,63.1
3080  DATA "PP-PY","BRAZIL",-9,53
3090  DATA "PY0","FERNANDO DE NORONHA",-3.85,32.45
3100  DATA " ","ST. PETER & PAUL'S ROCKS",1,30
3110  DATA " ","TRINIDADE",-22,31
3120  DATA "PZ","SURINAM",5.5,55
3130  DATA "S2,S3","BANGLADESH",24,-90
3140  DATA "S4","CISKEI",-30,-25
3150  DATA "S7","SEYCHELLES",-4.5,-55.66
3160  DATA "S8","TRANSKEI",-30,-25
3170  DATA "S9,CR5","SAO TOME & PRINCIPE",1,-7
3180  DATA "SJ-SM","SWEDEN",62,-15
3190  DATA "SP","POLAND",52,-19
3200  DATA "ST2","SUDAN",5,-31.8
3210  DATA "ST0","SOUTHERN SUDAN",15,-30
3220  DATA "SU","EGYPT",27,-30
3230  DATA "SV","GREECE",39,-22
3240  DATA " ","CRETE",35.5,-24.7
3250  DATA " ","MT ATHOS",40.1,-24.3
3260  DATA "SV5 ","DODECANESE",36.2,-27
3270  DATA "T2","TUVALU",-8,-178
3280  DATA "T7,M1","SAN MARINO",43.9,-12.4
3290  DATA "T30","W. KIRIBATI",-.5,-174
3300  DATA "T31","C. KIRIBATI",-4,-172
3310  DATA "T32","E. KIRIBATI",0,157
3320  DATA "TA-TC","TURKEY",39,-35
3330  DATA "TF","ICELAND",65,18
3340  DATA "TG","GUATEMALA",14.6,90.5
3350  DATA "TI","COSTA RICA",10,84
3360  DATA "TI9","COCOS IS",6,87.5
3370  DATA "TJ","CAMEROON",6,-12
3380  DATA "TL","CENTRAL AFR. REP.",7,-21
3390  DATA "TN","CONGO REP.",-1,-15
3400  DATA "TR","GABON REP.",-1,-11.75
3410  DATA "TT","CHAD REP.",15,-19
3420  DATA "TU","IVORY COAST",8,5
3430  DATA "TY","BENIN",9.5,-2.25
3440  DATA "TZ","MALI REP.",16,3.5
3450  DATA "UA1","EUR. RUSSIAN SFSR",59,-31
3460  DATA "UA3"," ",56,-38
3470  DATA "UA6"," ",47,-43
3480  DATA "UN1"," ",65,-32
3490  DATA "UA1","FRANZ JOSEF LAND",81,-55
3500  DATA "UA2","KALININGRADSK",54.7,-20.5
3510  DATA "UA9","ASIATIC RSFSR",55,-70
3520  DATA "UA0","ASIATIC RSFSR-ZONE 18",52,-105
3530  DATA "UA0","ASIATIC RSFSR-ZONE 19",43,-130
3540  DATA "UB5","UKRAINE",49,-32
3550  DATA "UC2","WHITE RSSR",53,-27
3560  DATA "UD6","AZERBAIJAN",40.5,-47.5
3570  DATA "UF6","GEORGIA",42,-44
3580  DATA "UG6","ARMENIA",40,-43
3590  DATA "UH8","TURKOMAN",40,-60
3600  DATA "UI8","UZBEK",41,-64
3610  DATA "UJ8","TADZHIK",39,-71
3620  DATA "UL7","KAZAKH",48,-68
3630  DATA "UM8","KIRGHIZ",41.5,-75
3640  DATA "UO5","MOLDAVIA",47,-29
3650  DATA "UP2","LITHUANIA",56,-24
3660  DATA "UQ2","LATVIA",57,-25
3670  DATA "UR2","ESTONIA",59,-26
3680  DATA "V2","ANTIGUA",17,61.8
3690  DATA "V3","BELIZE",17.25,88.75
3700  DATA "V4,VP2K","ST. KITTS",17.3,62.75
3710  DATA "V8","BRUNEI",4.8,-114.9
3720  DATA "V9","VENDA",-30,-25
3730  DATA "VE1","SABLE IS",44,60
3740  DATA " ","ST PAUL IS",47.2,60.2
3750  DATA "VE1","NEW BRUNS.,NOVA SCOTIA",47,65
3760  DATA "VE2","QUEBEC",47,72
3770  DATA "VE3","ONTARIO",45,78
3780  DATA "VE4","MANITOBA,WINNEPEG",50,97
3790  DATA "VE5","SASKATCHEWAN,SASKATOON",52.5,107
3800  DATA "VE6","ALBERTA,EDMONTON",53,113
3810  DATA "VE7","BRIT. COLUMBIA",55,124
3820  DATA "VE8","YUKON",65,135
3830  DATA "VE8","N.W. TERRITORY",65,105
3840  DATA "VO1","NEWFOUNDLAND",48,55
3850  DATA "VO2","LABRADOR",54,62
3860  DATA "VK1","AUSTRALIA-CAP TERR,CANBERRA",-35,-150
3870  DATA "VK2","   NEW S. WALES,NEWCASTLE",-32,-148
3880  DATA "VK3","   VICTORIA,MELBOURNE",-35,-145
3890  DATA "VK4","   QUEENSLAND,BRISBANE",-27.5,-153
3900  DATA "VK5","   S. AUSTR,WOOMERA",-31,-136.5
3910  DATA "VK6","   W. AUSTR,PERTH",-32,-116
3920  DATA "VK7","   TASMANIA,HOBART",-44,-147
3930  DATA "VK8","   N. TERRITORY,DARWIN",-12.5,-131
3940  DATA "VK2","LORD HOWE IS",-31.6,-159.1
3950  DATA "VK9","WILLIS IS",-16.3,-150
3960  DATA " ","CHRISTMAS IS",-10.5,-105.65
3970  DATA "VK9","COCOS IS",-12,-97
3980  DATA "VK9","MELLISH REEF",-17.4,-155.85
3990  DATA " ","NORFOLK IS",-29,-167.95
4000  DATA "VK0","HEARD IS",-53,-75
4010  DATA " ","MACQUARIE IS",-54.6,-158.9
4020  DATA "VP2E","ANGUILLA",18.25,63.10
4030  DATA "VP2M","MONTSERRAT",16.75,62.2
4040  DATA "VP2V","BRITISH VIRGIN IS",18.5,64.5
4050  DATA "VP5","TURKS & CAICOS IS",21.75,71.6
4060  DATA "VP8","FALKLAND IS",-51.75,59
4070  DATA " ","S. GEORGIA IS",-54.25,36.75
4080  DATA " ","S. ORKNEY IS",-62,45
4090  DATA " ","S. SANDWICH IS",-58,27
4100  DATA " ","S. SHETLAND IS",-62,60
4110  DATA "VP9","BERMUDA",32.35,64.75
4120  DATA "VQ9","CHAGOS IS",-6,-72
4130  DATA "VR6","PITCAIRN IS",-25.1,130.1
4140  DATA "VS6","HONG KONG",22.25,-114.2
4150  DATA "VU","INDIA",20,-80
4160  DATA "VU7","ANDAMAN & NICOBAR IS",12,-93
4170  DATA " ","LACCADIVE IS",10,-73
4180  DATA "XE","MEXICO",23,102
4190  DATA "XF4","REVILLA GIGEDO",19,111.5
4200  DATA "XT","BURKINA-FASO",12,2
4210  DATA "XU","KAMPUCHEA",13,-105
4220  DATA "XV","VIETNAM",13,-108
4230  DATA "XW","LAOS",18,-105
4240  DATA "XX","MACAO",22.15,-113.6
4250  DATA "XZ","BURMA",22,-98
4260  DATA "Y2-Y9","GERMAN DEM. REP",52,-12.3
4270  DATA "YA","AFGHANISTAN",34,-66
4280  DATA "YB,YC,YD","INDONESIA",-6.15,-106.8
4290  DATA "YI","IRAQ",33,-44
4300  DATA "YJ","VANUATU",-16,-167
4310  DATA "YK","SYRIA",35,-38
4320  DATA "YN,HT","NICARAGUA",13,85
4330  DATA "YO","ROMANIA",46,-25.5
4340  DATA "YS","EL SALVADOR",13.8,88.9
4350  DATA "YU","YUGOSLAVIA",44,-19
4360  DATA "YV","VENEZUELA",8,66
4370  DATA "YV0","AVES IS",12,65
4380  DATA "Z2","ZIMBABWE",-20,-30
4390  DATA "ZA","ALBANIA",41,-20
4400  DATA "ZB","GIBRALTAR",36.2,5.36
4410  DATA "ZC","CYPRUS (BRIT. MILITARY BASES)",35,-33
4420  DATA "ZD7","ST HELENA IS",-15.9,5.7
4430  DATA "ZD8","ASCENSION IS",-7.9,14.3
4440  DATA "ZD9","TRISTAN DE CUHNA & GOUGH IS",-37,12
4450  DATA "ZF","CAYMAN IS",19.5,80.5
4460  DATA "ZK1","S. COOK IS",-20,158
4470  DATA "ZK1","N. COOK IS",-10.5,161.5
4480  DATA "ZK2","NIUE IS",-19,169.85
4490  DATA "ZL","NEW ZEALAND",-41,-175
4500  DATA "  ","AUCKLAND & CAMPBELL IS",-52.5,-169
4510  DATA " ","CHATHAM IS",-43,176.5
4520  DATA " ","KERMADEC IS",-29.85,178.25
4530  DATA "ZM7","TOKELAUS",-9,171.75
4540  DATA "ZP","PARAGUAY",-23,58
4550  DATA "ZS1,2,4,5,6","S. AFRICA",-30,-25
4560  DATA "ZS2","PRNC. EDWARD & MARION IS",-46.6,-37.9
4570  DATA "ZS3","NAMIBIA",-22.5,-17
4580  DATA "1A0","SOVEREIGN MIL. ORDER OF MALTA",42.8,-12.8
4590  DATA "1S","SPRATLY",8.63,-111.9
4600  DATA "3A","MONACO",43.7,-7.4
4610  DATA "3B6,7","AGALEGA & ST BRANDON",-10.4,-56.6
4620  DATA "3B8","MAURITIUS",-20.5,-58
4630  DATA "3B9","RODIGUEZ",-19.7,-63.4
4640  DATA "3C","EQUATORIAL GUINEA",2,-9
4650  DATA "3C0","ANNOBON",-1.4,-5.6
4660  DATA "3D2","FIJI",-17,-178
4670  DATA "3D6","SWAZILAND",-27,-32
4680  DATA "3V","TUNISIA",35,-10
4690  DATA "3X","GUINEA",11,10
4700  DATA "3Y","BOUVET & PETER IS",-54.45,-3.4
4710  DATA "4S","SRI LANKA (CEYLON)",7,-81
4720  DATA "4U","I.T.U. GENEVA",41.2,-6.15
4730  DATA "4W","YEMEN",15,-44
4740  DATA "4X,4Z","ISRAEL",32,-35
4750  DATA "5A","LIBYA",32.5,-13
4760  DATA "5B","CYPRUS",35,-33
4770  DATA "5H","TANZANIA",-7,-38
4780  DATA "5N","NIGERIA",7,-5
4790  DATA "5R","MALAGASY REP",-19,-47.5
4800  DATA "5T","MAURITANIA",18,15
4810  DATA "5U","NIGER",15,-7
4820  DATA "5V","TOGO",7,1.5
4830  DATA "5W","W. SAMOA",-13.9,172
4840  DATA "5X","UGANDA",5,-32
4850  DATA "5Z","KENYA",-2.5,-38
4860  DATA "6O","SOMALI",2.5,-46
4870  DATA "6W","SENEGAL",14.5,17
4880  DATA "6Y","JAMAICA",18.25,77.3
4890  DATA "7O","PEOPLE'S DEM. REP. OF YEMEN",12.75,-45.2
4900  DATA "7P","LESOTHO",-29,-28
4910  DATA "7Q","MALAWI",-15,-35
4920  DATA "7X","ALGERIA",36.5,-2.5
4930  DATA "7Z,HZ","SAUDI ARABIA",25,-45
4940  DATA "8P","BARBADOS",13.15,59.55
4950  DATA "8Q,VS9","MALDIVE IS",3.25,-73
4960  DATA "8R","GUYANA",5,59
4970  DATA "9G","GHANA",6,1
4980  DATA "9H","MALTA",35.8,-14.6
4990  DATA "9J","ZAMBIA",-15,-28
5000  DATA "9K","KUWAIT",29.5,-47.8
5010  DATA "9L","SIERRA LEONE",8,12
5020  DATA "9M2","W MALAYSIA",3,-102
5030  DATA "9M6,8","E. MALAYSIA (SABAH, SARAWAK)",6,-116
5040  DATA "9N","NEPAL",28,-84
5050  DATA "9Q","ZAIRE",-5,-22
5060  DATA "9U","BURUNDI",-3,-30
5070  DATA "9V","SINGAPORE",1.35,-103.8
5080  DATA "9X","RWANDA",-2.5,-30
5090  DATA "9Y","TRINIDAD & TOBAGO",10.39,61.31
5100  DATA
