100  CLS :REM "HELICAL"
110  PRINT TAB(27);"****HELICAL RESONATORS****" :PRINT
120  REM W.MACALINE, R.SCHILDKENECHT-1959; A.ZVEREV-1967 & V.HEESEN-1985
130  PRINT :PRINT "THIS PROGRAM CALCULATES THE PHYSICAL and ELECTRICAL";
140  PRINT " PROPERTIES of" :PRINT "HELICAL COIL RESONATORS" :PRINT :PRINT
150  FL=0 :FO=0 :ZO=0 :BW=0 :RT=0 :LT=LOG(10) :PI=4*ATN(1)
160  PRINT :BEEP :INPUT "ENTER RESONATE FREQUENCY    (Mhz) ";FO
170  IF FO<5 OR FO>5000 THEN 1250
180  PRINT :BEEP :INPUT "ENTER RESONATOR IMPEDANCE  (ohms) ";ZO
190  IF ZO<200 OR ZO>5000 THEN 1250
200  PRINT :BEEP :INPUT "ENTER BW (3DB)    in Mhz";BW3
210  PRINT :BEEP :INPUT "ENTER IMPEDANCE of TAP  ";RT
220  D=98*10^3/(FO*ZO) :IF D<1 THEN 240 ELSE DS=INT(D*100)/100 :U$="inches"
230  GOTO 250
240  DS=INT(D*1000) :U$="mils"
250  LS=1.5*DS :IF D>1 THEN LS=INT(LS*100)/100 ELSE LS=INT(LS)
260  DC=0.55*DS :IF D>1 THEN DC=INT(DC*100)/100 ELSE DC=INT(DC)
270  L=1.5*DC :IF D>1 THEN L=INT(L*100)/100 ELSE L=INT(L)
280  N=1900/(FO*D) :N=INT(N*100)/100 :IF N<3.5 OR N>100  THEN 1250
290  QU=50*D*SQR(FO) :QU=INT(QU) :QUS=QU*1.2 :QUS=INT(QUS)
300  SP=(FO*(D^2))/2300 :SP=SP*1000 :SP=INT(SP*100)/100
310  SD=(2.606/SQR(FO))
320  WN=0.4*SP :WN=INT(WN*100)/100
330  WX=0.6*SP :WX=INT(WX*100)/100 :IF WX<(5*SD) THEN 1250
340  CLS :PRINT
350  PRINT TAB(26);CHR$(218); :FOR U=27 TO 39 :PRINT TAB(U);CHR$(196); :NEXT U
360  PRINT TAB(40);CHR$(191);TAB(43);CHR$(196);CHR$(194);CHR$(196)
370  PRINT TAB(26);CHR$(179);"-----Ds------";CHR$(179);"   ";CHR$(124)
380  PRINT TAB(26);CHR$(179);"  ";CHR$(179);"--Dc--";CHR$(179);TAB(40);CHR$(179);
390  PRINT "   ";CHR$(124)
400  PRINT TAB(26);CHR$(179);TAB(30);"_______";TAB(37);"/  ";CHR$(179);
410  PRINT CHR$(194);"  ";CHR$(124)
420  PRINT TAB(26);CHR$(179);"  (_______   ";CHR$(179);CHR$(124);"  ";CHR$(124)
430  PRINT TAB(26);CHR$(179);TAB(30);"_______)- ";CHR$(179);CHR$(124);"  Ls"
440  PRINT TAB(26);CHR$(179);"  (_______ sp";CHR$(179);"Lc ";CHR$(124)
450  PRINT TAB(26);CHR$(179);TAB(30);"_______)- ";CHR$(179);CHR$(124);"  ";
460  PRINT CHR$(124)
470  PRINT TAB(26);CHR$(179);"  (_______   ";CHR$(179);CHR$(124);"  ";CHR$(124)
480  PRINT TAB(26);CHR$(179);TAB(30);"_______)  ";CHR$(179);CHR$(124);"  ";
490  PRINT CHR$(124)
500  PRINT TAB(20);"TAP------(__________";CHR$(179);CHR$(193);"  ";CHR$(124)
510  PRINT TAB(26);CHR$(179);TAB(40);CHR$(179);"   ";CHR$(124)
520  PRINT TAB(26);CHR$(192);:FOR U=27 TO 39 :PRINT TAB(U);CHR$(196); :NEXT U
530  PRINT TAB(40);CHR$(217);TAB(43);CHR$(196);TAB(44);CHR$(193);TAB(45);
540  PRINT CHR$(196)
550  PRINT :PRINT "RESONATE FREQUENCY=";FO;"Mhz";TAB(35);"IMPEDANCE=";ZO;"ohms";
560  PRINT TAB(60);"BW (3DB)=";BW3;"Mhz"
570  PRINT :PRINT "SHIELD DIA.  (Ds)=";DS;U$;TAB(35);"SHIELD LENGTH (Ls)";
580  PRINT CHR$(247);LS;U$
590  PRINT "COIL DIA.    (Dc)=";DC;U$;TAB(35);"COIL LENGTH   (Lc)=";L;U$
600  PRINT "WIRE SPACING (sp)=";SP;"mils";TAB(35);"NUMBER OF TURNS   =";
610  PRINT INT(N*100)/100
620  PRINT "QU (round shield)=";QU;TAB(35);"QU (square shield)=";QUS
630  PRINT "WIRE DIA.   (MIN)=";WN;"mils";TAB(35);"WIRE DIA.    (MAX)=";WX;"mils"
640  QL=FO/BW3 :QO=QUS/QL
650  PRINT :BEEP :INPUT "ENTER No. OF POLES (2-7)";NP :IF NP>7 THEN 650
660  ON NP GOTO 650,670,680,690,700,710,720
670  Q1=1.412 :IL=20*(LOG((1.412/QO)+1)/LT) :GOTO 730
680  Q1=1 :IL=20*(LOG((2/QO^2)+(2/QO)+1)/LT) :GOTO 730
690  Q1=0.7654 :IL=20*(LOG((2.62/QO^3)+(3.41/QO^2)+(2.62/QO)+1)/LT) :GOTO 730
700  Q1=0.618 :IL=20*(LOG((3.24/QO^4)+(5.23/QO^3)+(5.23/QO^2)+(3.24/QO)+1)/LT) :GOTO 730
710  Q1=0.518 :IL=20*(LOG((3.84/QO^5)+(7.42/QO^4)+(9.11/QO^3)+(7.43/QO^2)+(3.84/QO)/LT) :GOTO 730
720  Q1=0.445 :IL=20*(LOG((4.46/QO^6)+(10/QO^5)+(14.5/QO^4)+(14.6/QO^3)+(10/QO^2)+(4.46/QO)+1)/LT)
730  PRINT :PRINT "INSERTION LOSS=";INT(IL*100)/100;"DB" :PRINT
740  QD=0.5*Q1*(FO/BW3) :RZ=(PI/4)*((1/QD)-(1/QU))
750  SN=SQR((RZ/2)*(RT/ZO)) :RAD=180/PI
760  SNN=ATN(SN)*RAD
770  TLN=(N*SNN)/90 :TLN=CINT(TLN*1000)/1000
780  TLD=N*SNN*4 :TLD=CINT(TLD)
790  PRINT "TAP LOCATION =";TLN;"TURNS or ";TLD;"DEGREES FROM GROUNDED END."
800  PRINT :BEEP :PRINT "HARD COPY REQUIRED? (Y/N)"
810  P$=INKEY$ :IF P$="" THEN 810
820  IF P$<>"Y" THEN 1210
830  LPRINT :LPRINT TAB(25);"*** HELICAL RESONATOR DESIGN ***" :IF FL=1 THEN 1080
840  LPRINT :LPRINT "PROJECT:----------------------------------------------";
850  LPRINT TAB(56);"DATE:------------------" :LPRINT :LPRINT
860  LPRINT TAB(6);CHR$(240); :FOR U=7 TO 19 :LPRINT TAB(U);CHR$(241); :NEXT U
870  LPRINT TAB(20);CHR$(242);TAB(23);CHR$(241);CHR$(243);CHR$(241);TAB(30);
880  LPRINT "NOTES: 1. BW (3DB)=";BW3;"; No.POLES=";NP
890  LPRINT TAB(6);CHR$(245);"-----Ds------";CHR$(245);"   ";CHR$(124);TAB(37);
900  LPRINT "2. Q (square shield used for INS. LOSS."
910  LPRINT TAB(6);CHR$(245);"  ";CHR$(245);"--Dc--";CHR$(245);TAB(20);
920  LPRINT CHR$(245);"   ";CHR$(124);TAB(37);"3."
930  LPRINT TAB(6);CHR$(245);TAB(10);"_______";TAB(17);"/  ";CHR$(245);
940  LPRINT CHR$(243);"  ";CHR$(124)
950  LPRINT TAB(6);CHR$(245);"  (_______   ";CHR$(245);CHR$(124);"  ";CHR$(124)
960  LPRINT TAB(6);CHR$(245);TAB(10);"_______)- ";CHR$(245);CHR$(124);"  Ls"
970  LPRINT TAB(6);CHR$(245);"  (_______ sp";CHR$(245);"Lc ";CHR$(124)
980  LPRINT TAB(6);CHR$(245);TAB(10);"_______)- ";CHR$(245);CHR$(124);"  ";
990  LPRINT CHR$(124)
1000  LPRINT TAB(6);CHR$(245);"  (_______   ";CHR$(245);CHR$(124);"  ";CHR$(124)
1010  LPRINT TAB(6);CHR$(245);TAB(10);"_______)  ";CHR$(245);CHR$(124);"  ";
1020  LPRINT CHR$(124)
1030  LPRINT "TAP-----(__________";CHR$(245);CHR$(248);"  ";CHR$(124)
1040  LPRINT TAB(6);CHR$(245);TAB(20);CHR$(245);"   ";CHR$(124)
1050  LPRINT TAB(6);CHR$(246);:FOR U=7 TO 19 :LPRINT TAB(U);CHR$(241); :NEXT U
1060  LPRINT TAB(20);CHR$(247);TAB(23);CHR$(241);TAB(24);CHR$(248);TAB(25);
1070  LPRINT CHR$(241) :FL=1 :KT=0
1080  LPRINT :LPRINT "RESONATE FREQUENCY=";FO;"Mhz";TAB(35);"IMPEDANCE=";ZO;
1090  LPRINT "ohms  INSERTION LOSS=";INT(IL*100)/100;"DB"
1100  LPRINT :LPRINT "SHIELD DIA.  (Ds)=";DS;U$;TAB(35);"SHIELD LENGTH (Ls)";
1110  LPRINT CHR$(126);LS;U$
1120  LPRINT "COIL DIA.    (Dc)=";DC;U$;TAB(35);"COIL LENGTH   (Lc)=";L;U$
1130  LPRINT "WIRE SPACING (sp)=";SP;"mils";TAB(35);"QU=";QU;"or";QUS;
1140  LPRINT "(square shield)" :LPRINT "NUMBER of TURNS=";INT(N*100)/100;
1150  LPRINT TAB(35)"WIRE DIA.   (MIN)=";WN;"mils" :LPRINT "TAP IMPEDANCE  =";
1160  LPRINT ;RT;"ohms";TAB(35);"WIRE DIA.   (MAX)=";WX;"MILS"
1170  IF KT<1 THEN 1190
1180  LPRINT "BANDWIDTH (3DB)=";BW3;TAB(35);"NUMBER of POLES  =";INT(NP)
1190  LPRINT "TAP LOCATION   =";TLN;"TURNS or";TLD;"DEGREES from GROUNDED END."
1200  KT=KT+1
1210  PRINT :BEEP :PRINT "RERUN PROGRAM? (Y/N)"
1220  A$=INKEY$ :IF A$="" THEN 1220
1230  IF A$="Y" THEN 160
1240  IF A$<>"N" THEN 1220 ELSE END
1250  PRINT :PRINT "THIS DESIGN IS INADVISABLE!!" :GOTO 1210
